# Uncertain Out-of-Domain Generalization

This package provides source codes and pre-trained models on Digits datasets.

## What do we need ?

This package has the following requirements:

* `Python 3.6`
* `Pytorch 1.1.0`
* `MetaNN 0.1.5`
* `Scipy 1.2.1`

```
pip install http://download.pytorch.org/whl/cu90/torch-1.1.0-cp36-cp36m-linux_x86_64.whl
pip install MetaNN scipy
```

## File structure

* data: MNIST and test sets of SVHN, MNIST-M, SYN, and USPS
* models: definition of the backbone and auxiliary models and pre-trained models.
* utils: loss functions and other supportive functions
* train.py: the source code to train our model
* test.py: the source code to deploy the trained model
* main.sh: script to download the test set of SVHN, load the pre-trained model, and run the test code

## How to run the test code ?

```
sh main.sh
```
